#!/bin/sh

#rdr378r0

SERV_IN_INIT=
DRV_PATH=
PLIST_PATH=
DRV_NAME=
LIB_PATH=/usr/lib

if [ $UID != 0 ]; then
    echo "This script require root privilege!"
    exit 1
fi

if [ -f /etc/init.d/pcscd ]; then
    SERV_IN_INIT=true
else
    SERV_IN_INIT=false
fi

host_cpu=
case `uname -m` in
  i[3456]86)
    host_cpu=x86
    ;;
  x86_64)
    host_cpu=x64
    ;;
  *)
    echo Unsupported OS
    exit 1
    ;;
esac

case $host_cpu in
  x86)
    DRV_NAME=libKP378-x86.so
    ;;
  x64)
    DRV_NAME=libKP378-x64.so
    ;;
esac

if [ -f /usr/sbin/pcscd ]; then
    if [ -d /usr/pcsc/drivers ]; then
      DRV_PATH=/usr/pcsc/drivers/ifd-KP378.bundle/Contents/Linux
      PLIST_PATH=/usr/pcsc/drivers/ifd-KP378.bundle/Contents
    elif [ -d /usr/lib/pcsc/drivers ]; then
      DRV_PATH=/usr/lib/pcsc/drivers/ifd-KP378.bundle/Contents/Linux
      PLIST_PATH=/usr/lib/pcsc/drivers/ifd-KP378.bundle/Contents
    fi
elif [ -f /usr/local/sbin/pcscd ]; then
    if [ -d /usr/local/lib/pcsc/drivers ]; then
      DRV_PATH=/usr/local/lib/pcsc/drivers/ifd-KP378.bundle/Contents/Linux
      PLIST_PATH=/usr/local/lib/pcsc/drivers/ifd-KP378.bundle/Contents
    fi
else
    echo "can't find pcscd in known location."
    echo "please install pcscd before installing this driver"
    exit 1
fi

echo "drv_path is: $DRV_PATH"
echo "drv_name is: $DRV_NAME"
echo "pcscd in init.d present: $SERV_IN_INIT"

echo "now copying necessary files. please wait."
mkdir -p $DRV_PATH
cp $host_cpu/$DRV_NAME $DRV_PATH/libKP378.so
cp $host_cpu/libauthorjni.so $LIB_PATH
cp $host_cpu/libnkidll.so $LIB_PATH
cp /usr/lib/pcsc/drivers/ifd-ccid.bundle/Contents/Info.plist $PLIST_PATH
echo "copying finished."

if [ $SERV_IN_INIT = true ]; then
    /etc/init.d/pcscd restart
else
    echo "please restart pcscd manualy"
fi

exit 0
