!define IBANK_INSTALL_PATH " "
; pc-banking.nsi         ;
;--------------------------------
; Include Modern UI       
  !verbose 0
  !include "System.nsh"       
  !verbose 0

  SetCompressor /SOLID lzma
;--------------------------------

Var JAVA_HOME
Var JAVA_VER

;--------------------------------
; Causes the NSIS compiler to scan the given directory for Plugin DLLs.
  !addplugindir ${NSISDIR}  

;  !define PLUGINSDIR ${NSISDIR}
;--------------------------------
; This command will set the level of verbosity. 4=all, 3=no script, 2=no info, 1=no warnings, 0=none.
;--------------------------------
;Sets whether or not an XP manifest will be added to the installer.
; An XP manifest makes the installer controls use the new XP style when running on Windows XP.
; This affects the uninstaller too.
  XPStyle on
  !verbose 3
;--------------------------------
;Interface Settings
  !define MUI_HEADERIMAGE
  !define MUI_ABORTWARNING


  !insertmacro MUI_DEFAULT MUI_ICON "install.ico"
  !insertmacro MUI_DEFAULT MUI_UNICON "install.ico"
  !insertmacro MUI_DEFAULT MUI_HEADERIMAGE_BITMAP "logo.bmp"
  !insertmacro MUI_DEFAULT MUI_HEADERIMAGE_UNBITMAP "logo.bmp"
  !insertmacro MUI_DEFAULT MUI_LANGDLL_WINDOWTITLE "iBank 2 UA PC Installer"
;  !insertmacro MUI_DEFAULT MUI_BGCOLOR "000000"
;Pages    
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
;--------------------------------
;Languages 
  !insertmacro MUI_LANGUAGE "Russian"
;  !insertmacro MUI_LANGUAGE "English"
  !insertmacro MUI_LANGUAGE "Ukrainian"
;--------------------------------
; The name of the installer
  LangString ARMCLIENT ${LANG_RUSSIAN} "iBank 2 UA   (PC-Banking)"
;  LangString ARMCLIENT ${LANG_ENGLISH} "iBank 2 Client (PC-Banking)"
  LangString ARMCLIENT ${LANG_UKRAINIAN} "iBank 2 UA  i (PC-Banking)"

  LangString TEXT ${LANG_RUSSIAN} "      $\"$\"!     $\"$\"     $\"iBank 2 UA$\"   ."
;  LangString TEXT ${LANG_ENGLISH} "English       $\"$\"!     $\"$\"     $\"iBank 2$\"   ."
  LangString TEXT ${LANG_UKRAINIAN} "      $\"i$\"!         $\"i$\"    i  $\"iBank 2 UA$\"   '."

  LangString SUBTEXT ${LANG_RUSSIAN} "B   :"
;  LangString SUBTEXT ${LANG_ENGLISH} "English B   :"
  LangString SUBTEXT ${LANG_UKRAINIAN} "Bi   :"

  LangString BROWSE_BUTTON_TEXT ${LANG_RUSSIAN} ""
;  LangString BROWSE_BUTTON_TEXT ${LANG_ENGLISH} "English "
  LangString BROWSE_BUTTON_TEXT ${LANG_UKRAINIAN} "i"

  LangString FILE_EXIST ${LANG_RUSSIAN} ' ""  .       .$\r$\n?'
;  LangString FILE_EXIST ${LANG_ENGLISH} 'English  ""  .       .$\r$\n?'
  LangString FILE_EXIST ${LANG_UKRAINIAN} ' "i"  .  i i i i  i?.$\r$\n?'

  LangString JAVA_VER_NOT_SUPPORT ${LANG_RUSSIAN} '  -  Sun Java Runtime Environment   1.4.0.$\r$\n  www.java.com     Sun JRE   .'
  LangString JAVA_VER_NOT_SUPPORT ${LANG_UKRAINIAN} ' -  Sun Java Runtime Environment    1.4.0.$\r$\n³  www.java.com     Sun JRE   .'
;  LangString JAVA_VER_NOT_SUPPORT ${LANG_ENGLISH} 'Sun Java Runtime Environment higher then 1.4.0 is required for PC-Banking instalation. To download and install the new version of Sun JRE go to www.java.com.'

  DirText $(TEXT) $(SUBTEXT) $(BROWSE_BUTTON_TEXT)
  
  Name $(ARMCLIENT)
;--------------------------------
  BrandingText "Copyright c 1999-2004 BIFIT"
; The file to write
  OutFile "PC-Banking.exe"
; The default installation directory
  InstallDir "$PROGRAMFILES\iBank2UA - ${IBANK_INSTALL_PATH}"
  CRCCheck "on"            
  ShowInstDetails "hide"
  ShowUninstDetails "hide"

;  LogSet on
;--------------------------------
;Installer Functions
  Function .onInit
    ;      
    StrCpy $1 "$PROGRAMFILES" "3"
    ReadRegStr $0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" "CurrentVersion"
    ; "6.0"  "6.1" -    
    StrCmp $0 "6.0" installInRoot
    StrCmp $0 "6.1" installInRoot
    StrCpy $1 "$PROGRAMFILES"
    Goto fin
    installInRoot:
    ;        (- UAC)
    StrCpy $1 "$PROGRAMFILES" "2"
    fin:
    StrCpy $INSTDIR "$1\iBank2UA - ${IBANK_INSTALL_PATH}"

    ;  Java  
    ReadRegStr $JAVA_VER HKLM "SOFTWARE\JavaSoft\Java Runtime Environment" CurrentVersion
    StrCmp "" "$JAVA_VER" noSunJVM
    ReadRegStr $0 HKLM "SOFTWARE\JavaSoft\Java Runtime Environment\$JAVA_VER" JavaHome
    GetFullPathName /SHORT $JAVA_HOME "$0"
    StrCmp $JAVA_VER "1.4" next
    StrCmp $JAVA_VER "1.5" next
    StrCmp $JAVA_VER "1.6" next
    Goto noSupportJavaVer
    next:
    IfFileExists "$JAVA_HOME\bin\javaw.exe" isSunJVM
    noSunJVM:
        MessageBox MB_OK|MB_ICONEXCLAMATION $(JAVA_VER_NOT_SUPPORT)
        Quit
    noSupportJavaVer:
        MessageBox MB_OK|MB_ICONEXCLAMATION $(JAVA_VER_NOT_SUPPORT)
        Quit
    isSunJVM:
    !insertmacro MUI_LANGDLL_DISPLAY
  FunctionEnd
;--------------------------------
  Section "install"
    IfFileExists $INSTDIR 0 skip_confirmation
      MessageBox MB_YESNO|MB_ICONEXCLAMATION  $(FILE_EXIST) IDYES skip_confirmation
      Quit
    skip_confirmation:
    Delete "$SMPROGRAMS\iBank2UA - ${IBANK_INSTALL_PATH}\*.*"
; remove shortcuts, if any.
    Delete "$DESKTOP\iBank2 UA PC - ${IBANK_INSTALL_PATH}.lnk"
;remove old shortcuts
    Delete "$DESKTOP\ .lnk"
    Delete "$DESKTOP\ iBank2 UA PC - ${IBANK_INSTALL_PATH}.lnk"
; remove files
    Delete "$INSTDIR\log\*.*"
    Delete "$INSTDIR\web\*.*"
    Delete "$INSTDIR\web\img\*.*"
    Delete "$INSTDIR\tmp\*.*"
    Delete "$INSTDIR\*.*"
; remove directories used.
    RMDir "$SMPROGRAMS\iBank2UA - ${IBANK_INSTALL_PATH}"
    RMDir "$INSTDIR\log"
    RMDir "$INSTDIR\web\img"
    RMDir "$INSTDIR\web"
    RMDir "$INSTDIR\tmp"
    RMDir "$INSTDIR"

    CreateDirectory "$SMPROGRAMS\iBank2UA - ${IBANK_INSTALL_PATH}"
    SetOutPath $INSTDIR

    Push $0

    CreateShortCut "$DESKTOP\iBank2 UA - ${IBANK_INSTALL_PATH}.lnk" \
                 "javaw" "-Xmx256M -cp launcher.jar com.bifit.launcher.Launcher" \
                 "$INSTDIR\pc-banking.ico" "0"

    CreateShortCut "$SMPROGRAMS\iBank2UA - ${IBANK_INSTALL_PATH}\iBank2 UA - ${IBANK_INSTALL_PATH}.lnk" \
                 "javaw" "-Xmx256M -cp launcher.jar com.bifit.launcher.Launcher" \
                 "$INSTDIR\pc-banking.ico" "0"

    CreateShortCut "$DESKTOP\iBank2UA -    .lnk" \
                 "javaw" "-cp sinker.jar com.bifit.sinker.RestoreWizard" \
                 "$INSTDIR\pc-banking.ico" "0"

    CreateShortCut "$SMPROGRAMS\iBank2UA - ${IBANK_INSTALL_PATH}\ iBank2 UA - ${IBANK_INSTALL_PATH}.lnk" \
                 "$INSTDIR\uninstall-PC-Banking - ${IBANK_INSTALL_PATH}.exe"

    Pop $0

    SetOutPath $INSTDIR

    File  ibank.odb
    File  logo.gif
    File  sinker.jar
    File  firmware.jar
    File  launcher.jar
    File  pc-banking.ico
    File  bjnidisp.dll
    File  jdial.dll
    File  "iBank2UA PC.bat"
    File  restore.bat

    SetOutPath $INSTDIR\client

    File  client\*


    WriteUninstaller "$INSTDIR\uninstall-PC-Banking - ${IBANK_INSTALL_PATH}.exe"
  SectionEnd

; special uninstall section.
  Section "Uninstall"
; remove shortcuts, if any.
    Delete "$SMPROGRAMS\iBank2UA - ${IBANK_INSTALL_PATH}\*.*"
    Delete "$DESKTOP\iBank2 UA - ${IBANK_INSTALL_PATH}.lnk"
    Delete "$DESKTOP\iBank2UA -    .lnk"
    RMDir "$SMPROGRAMS\iBank2UA - ${IBANK_INSTALL_PATH}"
; remove directories used.
    RMDir /r /REBOOTOK $INSTDIR
  SectionEnd
;--------------------------------
;Uninstaller Functions
  Function un.onInit
;Language selection dialog
     !insertmacro MUI_LANGDLL_DISPLAY
  FunctionEnd
; eof
